<?

/*
 * Flatbackup
 * Copyright (C) 2004 Aldo Boccacci
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the license, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

 /*
 * Sistema di backup per portali basati su flatnuke (flatnuke.sf.net)
 *
 * Autore: Aldo Boccacci
 * E-Mail: doc4it(AT)altervista.org
 * Sito web: doc4it.altervista.org
 * data ultima modifica: 16/10/2004
 * versione: 0.1.1
 */

/*
 * ATTENZIONE: QUESTA  UNA VERSIONE MODIFICATA DI FLATBACKUP PER PERMETTERNE
 * L'INTEGRAZIONE NEL FLATNUKE CONTROL CENTER. ADATTAMENTI DI:
 *	Marco Segato  <segatom (AT) yahoo (DOT) it>
 *	http://www.marcosegato.tk
 *	Ultima modifica 20041027
 */ 


//definisco l'etichetta da associare ai file
label($_POST['sitelabel']);

/*
 * La funzione che fa il backup :)
 */
function backup($what, $maxsize, $exclude_config_files){
	require_once "functions.php";
	require_once "shared.php";
	require_once "sections/".$_POST['post_mod']."/functions.inc.php";
	if(fncc_isadmin()){
		
		if ($what=="sections"){
			if (check_size("sections/",(disk_free_space("sections")-$maxsize))) {
				$dir = new DeepDir();
				$dir->setDir("sections");
				$dir->load();
				
				$backup = new zip_file("misc/backup/backup_sections_".SITE_LABEL.data().".zip");
				$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'storepaths','prepend','level','type'=>"zip"));
				foreach( $dir->files as $n => $pathToFile ){
					$backup->add_files($pathToFile);
				}
				$backup->create_archive();
				header("Location: ../../misc/backup/backup_sections_".SITE_LABEL.data().".zip");
			}
		}
	
		elseif ($what=="news"){
			$dir = new DeepDir();
			$dir->setDir("news");
			$dir->load();
			
			$backup = new gzip_file("misc/backup/backup_news_".SITE_LABEL.data().".tgz");
			$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'recurse','storepaths','level'));
			foreach( $dir->files as $n => $pathToFile ){
				$backup->add_files($pathToFile);
			}
			$backup->create_archive();
			header("Location: ../../misc/backup/backup_news_".SITE_LABEL.data().".tgz");
		}

		elseif ($what=="forum"){
			$dir = new DeepDir();
			$dir->setDir("forum/topics");
			$dir->load();
			
			$backup = new gzip_file("misc/backup/backup_topics_".SITE_LABEL.data().".tgz");
			$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'recurse','storepaths','level'));
			foreach( $dir->files as $n => $pathToFile ){
				$backup->add_files($pathToFile);
			}
			$backup->create_archive();
			header("Location: ../../misc/backup/backup_topics_".SITE_LABEL.data().".tgz");
		}

		elseif ($what=="misc"){
			$dir = new DeepDir();
			$dir->setDir("misc");
			$dir->load();
			
			$backup = new gzip_file("misc/backup/backup_misc_".SITE_LABEL.data().".tgz");
			$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'recurse','storepaths','level'));
			foreach( $dir->files as $n => $pathToFile ){
				$backup->add_files($pathToFile);
			}
			$backup->exclude_files("misc/backup/*");
			$backup->create_archive();
			header("Location: ../../misc/backup/backup_misc_".SITE_LABEL.data().".tgz");
		}

		elseif ($what=="users"){
			$dir = new DeepDir();
			$dir->setDir("forum/users");
			$dir->load();
			
			$backup = new gzip_file("misc/backup/backup_users_".SITE_LABEL.data().".tgz");
			$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'recurse','storepaths','level'));
			foreach( $dir->files as $n => $pathToFile ){
				$backup->add_files($pathToFile);
			}
			$backup->create_archive();
			header("Location: ../../misc/backup/backup_users_".SITE_LABEL.data().".tgz");
		}

		elseif ($what=="sito"){
			if (check_size(".",(disk_free_space(".")-$maxsize))) {
				$dir = new DeepDir();
				$dir->setDir("./");
				$dir->load();
				
				$backup = new zip_file("misc/backup/backup_site_".SITE_LABEL.data().".zip");
				$backup->set_options(array('inmemory'=>"0",'overwrite'=>1,'storepaths','prepend','level','type'=>"zip"));
				foreach( $dir->files as $n => $pathToFile ){
					$backup->add_files($pathToFile);
				}
				if ($exclude_config_files==1){
					$backup->exclude_files("./forum/users/*");
				}
				$backup->exclude_files("./misc/backup/*");
				$backup->create_archive();
				header("Location: ../../misc/backup/backup_site_".SITE_LABEL.data().".zip");
			}
		}
	}
}

/*
 * Per datare i backup
 */
function data(){
	return date("d-m-Y");
}

/*
 * Questa funzione controlla la dimensione della cartella di cui si deve fare il backup.
 * NOTA BENE: viene controllata la dimensione della cartella, NON del risultante file risultante di archivio!
 */
function check_size($dirpath,$maxsize){
	require_once "sections/".$_POST['post_mod']."/functions.inc.php";
	if (get_size($dirpath)<$maxsize){
		if (get_size($dirpath)<disk_free_space(".")){
			return true;
		}
		else {
			?><script language="javascript">alert('<?=_FCC_WARNINGNOSPACE?>');</script><?
			return false;
		}
	}
	else {
		?><script language="javascript">alert('<?=_FCC_WARNINGDIRBIGE?>');</script><?
		return false;
	}
}

/*
 * Genera la label per il nome dei backup
 */
function label($sitelabel){
	if (strlen($sitelabel)>15){
		define("SITE_LABEL","");
		return;
	}
	if ($sitelabel!=""){
		define("SITE_LABEL","$sitelabel"."_");	
	}
	else define("SITE_LABEL","");	
}

/*
 * Restituisce la dimensione di una directory
 */
function get_size($dirpath){
	$totalsize = 0;
	$dir = new DeepDir();
	$dir->setDir($dirpath);
	$dir->load();
	foreach( $dir->files as $n => $pathToFile ){
		$totalsize += filesize($pathToFile);
	}
	return $totalsize;
}

/*
 * Elimina files di backup temporanei
 */
function delete_backup(){
	require_once "functions.php";
	require_once "shared.php";
	require_once "sections/".$_POST['post_mod']."/functions.inc.php";
	if(fncc_isadmin()){
		$empty = true;
		foreach (glob("misc/backup/*") as $filename){
			$empty = false;
			if (unlink($filename)){
				?><script language="javascript">alert('<?=_FCC_WARNINGDELTMP." ".$filename?>');</script><?
			}
			else {
				?><script language="javascript">alert('<?=_FCC_WARNINGNODELTMP." ".$filename?>');</script><?
			}
		}
		if ($empty) {
			?><script language="javascript">alert('<?=_FCC_WARNINGNOTMP?>');</script><?
		}
	}
}

?>

